include windows.inc
include user32.inc
include kernel32.inc
include shell32.inc
include comctl32.inc
include comdlg32.inc
include gdi32.inc

include ..\SpreadSheet.inc

include masm32.inc
include \RadASM\masm\inc\debug.inc

includelib user32.lib
includelib kernel32.lib
includelib shell32.lib
includelib comctl32.lib
includelib comdlg32.lib
includelib gdi32.lib

includelib masm32.lib
includelib \RadASM\masm\lib\debug.lib


CreateClass				PROTO
DrawCell				PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
Compile					PROTO :DWORD,:DWORD
FindCell				PROTO :DWORD,:DWORD,:DWORD

IDB_BMP					equ 100
IDR_HSPLIT				equ	101
IDR_VSPLIT				equ 102

TPE_CELLREF				equ 080h			;Cell reference, internaly used
TPE_AREAREF				equ 081h			;Area reference, internaly used
TPE_SUMFUNCTION			equ 082h			;Function 'Sum(', internaly used
TPE_CNTFUNCTION			equ 083h			;Function 'Cnt(', internaly used
TPE_AVGFUNCTION			equ 084h			;Function 'Avg(', internaly used
TPE_MINFUNCTION			equ 085h			;Function 'Min(', internaly used
TPE_MAXFUNCTION			equ 086h			;Function 'Max(', internaly used
TPE_VARFUNCTION			equ 087h			;Function 'Var(', internaly used
TPE_STDFUNCTION			equ 088h			;Function 'Std(', internaly used
TPE_SQTFUNCTION			equ 089h			;Function 'Sqt(', internaly used
TPE_SINFUNCTION			equ 08Ah			;Function 'Sin(', internaly used
TPE_COSFUNCTION			equ 08Bh			;Function 'Cos(', internaly used
TPE_TANFUNCTION			equ 08Ch			;Function 'Tan(', internaly used
TPE_RADFUNCTION			equ 08Dh			;Function 'Rad(', internaly used
TPE_PIFUNCTION			equ 08Eh			;Function 'PI()', internaly used
TPE_IIFFUNCTION			equ 08Fh			;Function 'IIf(', internaly used
TPE_ONFUNCTION			equ 090h			;Function 'On(', internaly used
TPE_ABSFUNCTION			equ 091h			;Function 'Abs(', internaly used
TPE_SGNFUNCTION			equ 092h			;Function 'Sgn(', internaly used
TPE_INTFUNCTION			equ 093h			;Function 'Int(', internaly used
TPE_LOGFUNCTION			equ 094h			;Function 'Log(', internaly used
TPE_LNFUNCTION			equ 095h			;Function 'Ln(', internaly used
TPE_EFUNCTION			equ 096h			;Function 'e()', internaly used
TPE_ASINFUNCTION		equ 097h			;Function 'Asin()', internaly used
TPE_ACOSFUNCTION		equ 098h			;Function 'Acos()', internaly used
TPE_ATANFUNCTION		equ 099h			;Function 'Atan()', internaly used
TPE_GRDFUNCTION			equ 09Ah			;Function 'Grd(', internaly used
TPE_RGBFUNCTION			equ 09Bh			;Function 'Rgb(', internaly used
TPE_XFUNCTION			equ 09Ch			;Function 'x()', internaly used
TPE_RELCELLREF			equ 09Dh			;Relative cell reference, internaly used

TPE_STRING				equ 0D0h			;Immediate string

TPE_NOTEQU				equ 0F0h			;Operator <>, internaly used
TPE_GTOREQU				equ 0F1h			;Operator >=, internaly used
TPE_LEOREQU				equ 0F2h			;Operator <=, internaly used
TPE_GT					equ 0F3h			;Operator >, internaly used
TPE_EQU					equ 0F4h			;Operator =, internaly used
TPE_LE					equ 0F5h			;Operator <, internaly used

TPE_AND					equ 0F7h			;Logical operator And, internaly used
TPE_OR					equ 0F8h			;Logical operator Or, internaly used
TPE_XOR					equ 0F9h			;Logical operator Xor, internaly used

TPE_GRPFUNCTION			equ 0FAh			;Graph Grp(
TPE_GRPTFUNCTION		equ 0FBh			;Graph T(
TPE_GRPXFUNCTION		equ 0FCh			;Graph X(
TPE_GRPYFUNCTION		equ 0FDh			;Graph Y(
TPE_GRPGXFUNCTION		equ 0FEh			;Graph G(
TPE_GRPFXFUNCTION		equ 0FFh			;Graph fx(

PROP_STYLETRUEFALSE		equ 1
PROP_EXSTYLETRUEFALSE	equ 2
PROP_STYLEMULTI			equ 3

;Used by RadASM 1.2.0.5
CCDEF struct
	ID			dd ?						;Controls uniqe ID
	lptooltip	dd ?						;Pointer to tooltip text
	hbmp		dd ?						;Handle of bitmap
	lpcaption	dd ?						;Pointer to default caption text
	lpname		dd ?						;Pointer to default id-name text
	lpclass		dd ?						;Pointer to class text
	style		dd ?						;Default style
	exstyle		dd ?						;Default ex-style
	flist1		dd ?						;Property listbox 1
	flist2		dd ?						;Property listbox 2
	disable		dd ?						;Disable controls child windows. 0=No, 1=Use method 1, 2=Use method 2
CCDEF ends

;Used by RadASM 2.1.0.4
CCDEFEX struct
	ID					dd ?		;Controls uniqe ID
	lptooltip			dd ?		;Pointer to tooltip text
	hbmp				dd ?		;Handle of bitmap
	lpcaption			dd ?		;Pointer to default caption text
	lpname				dd ?		;Pointer to default id-name text
	lpclass				dd ?		;Pointer to class text
	style				dd ?		;Default style
	exstyle				dd ?		;Default ex-style
	flist1				dd ?		;Property listbox 1
	flist2				dd ?		;Property listbox 2
	flist3				dd ?		;Property listbox 3
	flist4				dd ?		;Property listbox 4
	lpproperty			dd ?		;Pointer to properties text to add
	lpmethod			dd ?		;Pointer to property methods
CCDEFEX ends

.const

szToolTip			db 'SpreadSheet',0
szCap				db 0
szName				db 'IDC_SPR',0
szClassNameSheet	db 'SPREAD_SHEET',0
szClassNameSheetWin	db 'SHEET_WIN',0
szClassNameEdit		db 'EDIT',0
szNULL				db 0
szFont				db 'MS Sans Serif',0
szListBox			db 'LISTBOX',0

STYLE				equ WS_CHILD or WS_VISIBLE or SPS_VSCROLL or SPS_HSCROLL or SPS_STATUS or SPS_GRIDLINES or SPS_CELLEDIT
EXSTYLE				equ WS_EX_CLIENTEDGE

MEMMAX				equ 4*1024*1024
COLMAX				equ 255
ROWMAX				equ 255
WINMAX				equ 8
FONTMAX				equ 16

HDRWT				equ 23
HDRHT				equ 17
CELLWT				equ 75
CELLHT				equ 17

STATUSHT			equ 17*2
INPHT				equ 17
SBSIZE				equ 16

WIN struct
	hwin			dd ?
	nwin			dd ?
	rect			RECT <?>
	hdc				dd ?
	mdc				dd ?
	act				dd ?
	tcol			dd ?
	trow			dd ?
	ccol			dd ?
	crow			dd ?
	mcol			dd ?
	mrow			dd ?
	lcol			dd ?
	lrow			dd ?
	sflag			dd ?
	scur			dd ?
	scurpt			POINT <?>
	scol			dd ?
	srow			dd ?
	sync			dd ?
WIN ends

SHEET STRUCT
	hwnd			dd ?
	winst			dd ?
	nid				dd ?
	howner			dd ?
	lpstart			dd ?
	lpend			dd ?
	lpcol			dd ?
	lprow			dd ?
	hedt			dd ?
	fedt			dd ?
	spri			SPR_ITEM <>
	gfmt			GLOBAL <>
	ofont			FONT FONTMAX dup(<?>)
	nwin			dd ?
	owin			WIN WINMAX+1 dup(<?>)
SHEET ends

COLDTA STRUCT
	len				dw ?
	coln			dw ?
	expx			db ?					;Expanded columns
	expy			db ?					;Expanded rows
	state			db ?
	fmt				FORMAT <?>
COLDTA ends

ROWDTA STRUCT
	len				dd ?
	rown			dw ?
	rowht			dw ?
	colend			dd ?
ROWDTA ends

GAXIS struct
	min				dt ?
	max				dt ?
	origo			dt ?
	factor			dt ?
	porigo			dd ?
	tick			dt ?
	fnt				dd ?
	color			dd ?
	lpcap			dd ?
GAXIS ends

GTEXT struct
	x				dd ?
	y				dd ?
	rotate			dd ?
	fnt				dd ?
	color			dd ?
	lpcap			dd ?
GTEXT ends

GGX struct
	fcol			dd ?
	frow			dd ?
	tcol			dd ?
	trow			dd ?
	fnt				dd ?
	color			dd ?
	lpcap			dd ?
GGX ends

GFX struct
	lpfun			dd ?
	step			dt ?
	fnt				dd ?
	color			dd ?
	lpcap			dd ?
GFX ends

GRAPH struct
	rc				RECT <?>
	grc				RECT <?>
	x				GAXIS <?>
	y				GAXIS <?>
GRAPH ends

flpe				dt 2.7182818284590452353602874713527
iL2e				dt 3FFEB17217F7D1CF79ACh
flpten				dt 10.0

.data

szProperty			db 'ScrollBar,Status,GridLines,RowSelect,GridMode,CellEdit',0
PropertyScrollBar	db 'None,Horizontal,Vertical,Both',0
					dd -1 xor (SPS_HSCROLL or SPS_VSCROLL),0
					dd -1,0
					dd -1 xor (SPS_HSCROLL or SPS_VSCROLL),SPS_HSCROLL
					dd -1,0
					dd -1 xor (SPS_HSCROLL or SPS_VSCROLL),SPS_VSCROLL
					dd -1,0
					dd -1 xor (SPS_HSCROLL or SPS_VSCROLL),SPS_HSCROLL or SPS_VSCROLL
					dd -1,0
PropertyStatus		dd -1 xor SPS_STATUS,0
					dd -1 xor SPS_STATUS,SPS_STATUS
PropertyGridLines	dd -1 xor SPS_GRIDLINES,0
					dd -1 xor SPS_GRIDLINES,SPS_GRIDLINES
PropertyRowSelect	dd -1 xor SPS_ROWSELECT,0
					dd -1 xor SPS_ROWSELECT,SPS_ROWSELECT
PropertyGridMode	dd -1 xor SPS_GRIDMODE,0
					dd -1 xor SPS_GRIDMODE,SPS_GRIDMODE
PropertyCellEdit	dd -1 xor SPS_CELLEDIT,0
					dd -1 xor SPS_CELLEDIT,SPS_CELLEDIT

Methods				dd PROP_STYLEMULTI,offset PropertyScrollBar
					dd PROP_STYLETRUEFALSE,offset PropertyStatus
					dd PROP_STYLETRUEFALSE,offset PropertyGridLines
					dd PROP_STYLETRUEFALSE,offset PropertyRowSelect
					dd PROP_STYLETRUEFALSE,offset PropertyGridMode
					dd PROP_STYLETRUEFALSE,offset PropertyCellEdit
				
ccdef				CCDEF <256,offset szToolTip,0,offset szCap,offset szName,offset szClassNameSheet,STYLE,EXSTYLE,11111101000111000000000001000000b,00010000000000011000000000000000b,1>
ccdefex				CCDEFEX <256,offset szToolTip,0,offset szCap,offset szName,offset szClassNameSheet,STYLE,EXSTYLE,11111101000111000000000001000000b,00010000000000011000000000000000b,0,0,offset szProperty,offset Methods>

.data?

hInstance			dd ?
strHex				db 16 dup(?)
OldEditProc			dd ?
hCurArrow			dd ?
hCurSize			dd ?
hCurVSplit			dd ?
hCurHSplit			dd ?

nCalcCol			dd ?					;Used by relative cell reference
nCalcRow			dd ?					;Used by relative cell reference
nCalcCells			dd ?					;Used by RecalcSheet
acmltr0				dt ?
funx				dt ?
buff				db 4096 dup(?)
lpHyperlink			dd ?
OldHyperlinkCol		dd ?
HyperLinkRect		RECT <?>
hCtrl				dd ?
hCurrent			dd ?
lpCellData			dd ?
