.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include SprTest.inc

.code

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax

    invoke InitCommonControls
	invoke CreateClass
	invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	invoke ExitProcess,0

;########################################################################

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	spri:SPR_ITEM
	LOCAL	rect:RECT

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		;Get spread sheet window handle
		invoke GetDlgItem,hWin,IDC_SPR1
		mov		hSpr,eax
		;Create ComboBox
		invoke SendMessage,hSpr,SPRM_CREATECOMBO,0,0
		mov		hCombo,eax
		;Set ComboBox font
		invoke SendMessage,hWin,WM_GETFONT,0,0
		invoke SendMessage,hCombo,WM_SETFONT,eax,FALSE
		;Put some data into the ComboBox
		push	esi
		mov		esi,offset cbdata
		.while byte ptr [esi]
			invoke SendMessage,hCombo,LB_ADDSTRING,0,esi
			invoke lstrlen,esi
			lea		esi,[esi+eax+1]
		.endw
		pop		esi
		;Set up an item struct
		;flag specify valid struct items
		mov		spri.flag,SPRIF_DATA or SPRIF_TYPE or SPRIF_WIDTH or SPRIF_IMAGEALIGN or SPRIF_TEXTALIGN
		mov		spri.fmt.imgal,FMTA_LEFT
		mov		spri.fmt.txtal,FMTA_LEFT
		;Plain text
		mov		spri.fmt.tpe,TPE_TEXT
		;Col 1
		mov		spri.col,1
		;Row 1
		mov		spri.row,1
		;And a pointer to text
		mov		spri.lpdta,offset szSomeText1
		;Width
		mov		spri.wt,200
		;Insert the item
		invoke SendMessage,hSpr,SPRM_SETCELLDATA,0,addr spri
		;Col 1
		mov		spri.col,1
		;Row 2
		mov		spri.row,2
		;And a pointer to text
		mov		spri.lpdta,offset szSomeText2
		;Insert the item
		invoke SendMessage,hSpr,SPRM_SETCELLDATA,0,addr spri

		;Hyperlink
		mov		spri.fmt.tpe,TPE_HYPERLINK
		;Col 1
		mov		spri.col,1
		;Row 3
		mov		spri.row,3
		;And a pointer to text
		mov		spri.lpdta,offset szHyperlink
		;Insert the item
		invoke SendMessage,hSpr,SPRM_SETCELLDATA,0,addr spri

		;Button
		mov		spri.fmt.tpe,TPE_BUTTON or TPE_TEXT
		;Col 1
		mov		spri.col,1
		;Row 4
		mov		spri.row,4
		;And a pointer to text
		mov		spri.lpdta,offset szHyperlink
		;Insert the item
		invoke SendMessage,hSpr,SPRM_SETCELLDATA,0,addr spri

		;Wide button
		mov		spri.fmt.tpe,TPE_WIDEBUTTON or TPE_TEXT
		;Col 1
		mov		spri.col,1
		;Row 5
		mov		spri.row,5
		;And a pointer to text
		mov		spri.lpdta,offset szHyperlink
		;Insert the item
		invoke SendMessage,hSpr,SPRM_SETCELLDATA,0,addr spri

		;CheckBox
		mov		spri.fmt.tpe,TPE_CHECKBOX
		;Col 1
		mov		spri.col,1
		;Row 6
		mov		spri.row,6
		;And a pointer to data+text
		mov		spri.lpdta,offset szCheck
		;Insert the item
		invoke SendMessage,hSpr,SPRM_SETCELLDATA,0,addr spri

		;CheckBox - Checked
		mov		spri.fmt.imgal,FMTA_RIGHT
		mov		spri.fmt.tpe,TPE_CHECKBOX
		;Col 1
		mov		spri.col,1
		;Row 7
		mov		spri.row,7
		;And a pointer to text
		mov		spri.lpdta,offset szCheckChecked
		;Insert the item
		invoke SendMessage,hSpr,SPRM_SETCELLDATA,0,addr spri

		;ComboBox
		mov		spri.fmt.tpe,TPE_COMBOBOX
		;Col 1
		mov		spri.col,1
		;Row 8
		mov		spri.row,8
		;And a pointer to data
		mov		spri.lpdta,offset dtCombo
		;Insert the item
		invoke SendMessage,hSpr,SPRM_SETCELLDATA,0,addr spri

		;ComboBox
		;flag specify valid struct items
		mov		spri.fmt.tpe,TPE_COMBOBOX
		mov		spri.fmt.imgal,FMTA_RIGHT
		mov		spri.fmt.txtal,FMTA_RIGHT
		;Col 2
		mov		spri.col,2
		;Row 8
		mov		spri.row,8
		;And a pointer to data
		mov		spri.lpdta,offset dtCombo
		;Insert the item
		invoke SendMessage,hSpr,SPRM_SETCELLDATA,0,addr spri

		;Force text
		mov		spri.fmt.tpe,TPE_FORCETEXT
		mov		spri.fmt.imgal,FMTA_AUTO
		mov		spri.fmt.txtal,FMTA_AUTO
		;Col 1
		mov		spri.col,1
		;Row 9
		mov		spri.row,9
		;And a pointer to text
		mov		spri.lpdta,offset szForcedText
		;Insert the item
		invoke SendMessage,hSpr,SPRM_SETCELLDATA,0,addr spri

		;Force text
		mov		spri.fmt.tpe,TPE_FORCETEXT
		;Col 1
		mov		spri.col,1
		;Row 9
		mov		spri.row,10
		;And a pointer to text
		mov		spri.lpdta,offset szForcedText
		;Insert the item
		invoke SendMessage,hSpr,SPRM_SETCELLDATA,0,addr spri

		;Cell ref to CheckBox
		mov		spri.flag,SPRIF_DATA or SPRIF_TYPE or SPRIF_COMPILE
		mov		spri.fmt.tpe,TPE_FORMULA
		;Col 1
		mov		spri.col,1
		;Row 11
		mov		spri.row,11
		;And a pointer to text
		mov		spri.lpdta,offset szCellRef1
		;Insert the item
		invoke SendMessage,hSpr,SPRM_SETCELLDATA,0,addr spri

		;Cell ref to ComboBox
		mov		spri.flag,SPRIF_DATA or SPRIF_TYPE or SPRIF_COMPILE
		mov		spri.fmt.tpe,TPE_FORMULA
		;Col 1
		mov		spri.col,1
		;Row 12
		mov		spri.row,12
		;And a pointer to text
		mov		spri.lpdta,offset szCellRef2
		;Insert the item
		invoke SendMessage,hSpr,SPRM_SETCELLDATA,0,addr spri

		;Recalculate sheet
		invoke SendMessage,hSpr,SPRM_RECALC,0,0
	.elseif eax==WM_CLOSE
		invoke EndDialog,hWin,0
	.elseif eax==WM_SIZE
		invoke GetClientRect,hWin,addr rect
		invoke MoveWindow,hSpr,0,0,rect.right,rect.bottom,TRUE
	.elseif eax==WM_NOTIFY
		mov		edx,lParam
		mov		eax,[edx].NMHDR.hwndFrom
		.if eax==hSpr
			mov		eax,[edx].NMHDR.code
			.if eax==SPRN_BEFOREEDIT
				;Get pointer to SPR_ITEM
				mov		ecx,[edx].SPR_EDIT.lpspri
				;Get the cell type
				movzx	eax,[ecx].SPR_ITEM.fmt.tpe
				.if eax==TPE_HYPERLINK
					;Cancel the edit operation
					mov		[edx].SPR_EDIT.fcancel,TRUE
				.endif
			.elseif eax==SPRN_HYPERLINKENTER
				;Get pointer to SPR_ITEM
				mov		ecx,[edx].SPR_HYPERLINK.lpspri
				;Change the cell text color from the default blue
				mov		[ecx].SPR_ITEM.fmt.txtcol,008000h
			.elseif eax==SPRN_HYPERLINKCLICK
				;Get pointer to SPR_ITEM
				mov		ecx,[edx].SPR_HYPERLINK.lpspri
				;Get pointer to text
				mov		eax,[ecx].SPR_ITEM.lpdta
				invoke ShellExecute,hWin,offset szOpen,eax,NULL,NULL,SW_SHOWDEFAULT
			.elseif eax==SPRN_BUTTONCLICK
				PrintText "Button click"
			.endif
		.endif
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DlgProc endp

end start
